local addOn, ns = ...
local L = ns.L

local testSearchSameSession = true

--[==[

	self:RegisterEvent("LOOT_OPENED");
	self:RegisterEvent("LOOT_SLOT_CLEARED");
	self:RegisterEvent("LOOT_SLOT_CHANGED");
	self:RegisterEvent("LOOT_CLOSED");
	self:RegisterEvent("LOOT_READY");
	self:RegisterEvent("OPEN_MASTER_LOOT_LIST");
	self:RegisterEvent("UPDATE_MASTER_LOOT_LIST");
	
	
]==]
--[==[

	LootSlotHasItem(slot)
	local texture, item, quantity, quality, locked, isQuestItem, questId, isActive = GetLootSlotInfo(slot);
	
]==]

local GetItemInfo = GetItemInfo

local events = CreateFrame('Frame')
events:SetScript('OnEvent', function(self, event, ...)
	self[event](self, event, ...)
end)
events:RegisterEvent('LOOT_OPENED')
events:RegisterEvent("LOOT_SLOT_CLEARED");
events:RegisterEvent("LOOT_SLOT_CHANGED");
events:RegisterEvent("LOOT_CLOSED");
events:RegisterEvent('UNIT_SPELLCAST_SUCCEEDED');
events:RegisterEvent('UNIT_SPELLCAST_SENT');

local lootInterator = {}
local activeLootRolls = {}
local lootFrames = {}

local IconSize = 32

local mover = CreateFrame("Frame", nil, UIParent)
--mover:EnableMouse(true)
mover:SetMovable(true)
mover:RegisterForDrag("LeftButton")
mover:SetPoint("CENTER", UIParent, "CENTER", 0,0)
mover:SetSize(328, 28)
--[[
mover.bg = mover:CreateTexture()
mover.bg:SetAllPoints()
mover.bg:SetTexture(0,0,0,0.6)
]]
mover:SetScript("OnDragStart", function()
	ns:StartServerSideMoving()
end)
mover:SetScript("OnDragStop", function()
	ns:StopServerSideMoving()
end)
--[[
mover.text = mover:CreateFontString()
mover.text:SetPoint("CENTER", mover, "CENTER", 0,0)
mover.text:SetFont(ns.default_font, ns.default_font_size, ns.default_font_outline)
mover.text:SetText('ServerSide Mover')
]]
function ns:StartServerSideMoving()
	mover:StartMoving()
end
function ns:StopServerSideMoving()
	mover:StopMovingOrSizing()	
	local x, y = mover:GetCenter()
	local ux, uy = UIParent:GetCenter()
	ns.db.ServerSizeMover = { floor(x - ux + 0.5),floor(y - uy + 0.5) }
	ns:UpdateServerSizePosition()
end
function ns:UpdateServerSizePosition()
	mover:SetPoint("CENTER", UIParent, "CENTER", ns.db.ServerSizeMover[1] or 0, ns.db.ServerSizeMover[2] or 0)
end

local HideTip = ns.HideTip
local HideTip2  = ns.HideTip2
local SetTip = ns.SetTip
local SetItemTip = ns.SetItemTip
local ItemOnUpdate = ns.ItemOnUpdate
local LootClick = ns.LootClick

ns.TakeAllItemsButton = CreateFrame('Button')
ns.TakeAllItemsButton:RegisterForClicks("RightButtonUp")
ns.TakeAllItemsButton:SetSize(54, 16)	

ns.TakeAllItemsButton.bg = ns.TakeAllItemsButton:CreateTexture()
ns.TakeAllItemsButton.bg:SetDrawLayer('OVERLAY', 1)
ns.TakeAllItemsButton.bg:SetAllPoints()
ns.TakeAllItemsButton.bg:SetTexture(ns.buttonsTexture)
ns.TakeAllItemsButton.bg:SetVertexColor(0.6, 0.6, 0.1, 1)

ns.TakeAllItemsButton.highlight = ns.TakeAllItemsButton:CreateTexture()
ns.TakeAllItemsButton.highlight:SetDrawLayer('OVERLAY', 2)
ns.TakeAllItemsButton.highlight:SetAllPoints()
ns.CustomSetTexture(ns.TakeAllItemsButton.highlight, 1,1,1,0.2)
ns.TakeAllItemsButton.highlight:Hide()
	
ns.TakeAllItemsButton.border = ns.TakeAllItemsButton:CreateTexture()
ns.TakeAllItemsButton.border:SetDrawLayer('OVERLAY', 0)
ns.TakeAllItemsButton.border:SetSize(1,1)
ns.TakeAllItemsButton.border:SetPoint("TOPLEFT", ns.TakeAllItemsButton.bg, 'TOPLEFT', -1, 1)
ns.TakeAllItemsButton.border:SetPoint("BOTTOMRIGHT", ns.TakeAllItemsButton.bg, 'BOTTOMRIGHT', 1, -1)
ns.CustomSetTexture(ns.TakeAllItemsButton.border, 0, 0, 0, 1)

ns.TakeAllItemsButton.text = ns.TakeAllItemsButton:CreateFontString()
ns.TakeAllItemsButton.text:SetDrawLayer('OVERLAY')
ns.TakeAllItemsButton.text:SetPoint('CENTER', ns.TakeAllItemsButton, 'CENTER', 0, 0)
ns.TakeAllItemsButton.text:SetFont(ns.default_font, ns.default_font_size, ns.default_font_outline)
ns.TakeAllItemsButton.text:SetText(L['GUI_TAKEALL'])	
ns.TakeAllItemsButton.text:SetShadowColor(0,0,0,1)
ns.TakeAllItemsButton.text:SetShadowOffset(1,-1)
ns.TakeAllItemsButton:SetScript('OnEnter', function(self)
	self.highlight:Show()
end)
ns.TakeAllItemsButton:SetScript('OnLeave', function(self)
	self.highlight:Hide()
end)
ns.TakeAllItemsButton:SetScript('OnMouseUp', function(self, button)
	if button ~= 'RightButton' then return end
	self.text:SetPoint('CENTER', self, 'CENTER', 0, 0)
end)
ns.TakeAllItemsButton:SetScript('OnMouseDown', function(self, button)
	if button ~= 'RightButton' then return end
	self.text:SetPoint('CENTER', self, 'CENTER', 1, -1)
end)

ns.TakeAllItemsButton:SetScript('OnClick', function(self, button)
	ns.print('T', 'OnClick', 'TakeAllItemsButton', button)
	if button ~= 'RightButton' then return end
	
	local playerName = UnitName('player')
	
	for slot=1, GetNumLootItems() do		
		if LootSlotHasItem(slot) then
			if ns:IsMasterLooter(true) then
				local index = ns:GetMasterLootCandidateIndex(slot, playerName)						
				if index then
			--		print('T', 'TakeAllItemsButton', 'GiveMasterLoot', slot, index)
					GiveMasterLoot(slot, index, 'LHLootAll')
				else
			--		print('T', 'TakeAllItemsButton', 'GiveMasterLoot', 'Error on find index for', playerName)
				end
			else
			--	print('T', 'TakeAllItemsButton', 'GiveMasterLootSlotLoot', slot)
				
				LootSlot(slot)
			end
		end
	end
end)


ns.ReceiveTooltip = CreateFrame("Frame")
ns.ReceiveTooltip:SetSize(300, 150)
ns.ReceiveTooltip:SetFrameStrata('TOOLTIP')
ns.ReceiveTooltip:Hide()

ns.ReceiveTooltip.text = ns.ReceiveTooltip:CreateFontString(nil, 'ARTWORK')
ns.ReceiveTooltip.text:SetPoint("TOP", ns.ReceiveTooltip, "TOP", 0 , -3)
ns.ReceiveTooltip.text:SetTextColor(1, 1, 1)
ns.ReceiveTooltip.text:SetJustifyH("LEFT")
ns.ReceiveTooltip.text:SetJustifyV("TOP")
ns.ReceiveTooltip.text:SetWordWrap(true)
ns.ReceiveTooltip.text:SetFont(ns.default_font, ns.default_font_size+1, 'NONE')
ns.ReceiveTooltip.text:SetShadowColor(0,0,0,1)
ns.ReceiveTooltip.text:SetShadowOffset(1,-1)
ns.ReceiveTooltip.text:SetText('TestHeader')

ns.ReceiveTooltip.bg = ns.ReceiveTooltip:CreateTexture(nil, 'BACKGROUND')
ns.ReceiveTooltip.bg:SetPoint('TOPLEFT', ns.ReceiveTooltip.text, 'TOPLEFT', -10, 10)
ns.ReceiveTooltip.bg:SetPoint('BOTTOMRIGHT', ns.ReceiveTooltip.text, 'BOTTOMRIGHT', 10, -2)
ns.ReceiveTooltip.bg:SetColorTexture(0,0,0,0.9)

local groupedItems = {}
local tempGroupedItems = {}

function ns.Server_AddItemToGroup(link, add)

	if not ns.db.groupUpSameItems then 
		return false
	end
	local link1 = ns.NumericItemLink(link, 'Server_AddItemToGroup:1')
	
	if tempGroupedItems[link1] then 
		tempGroupedItems[link1] = tempGroupedItems[link1] + 1
		
		return true, tempGroupedItems[link1]
	end
	
	if add then
		tempGroupedItems[link1] = tempGroupedItems[link1] or 1
	end
	
	return false
end

function ns.Server_GroupedItemInList(link, list)
	local exists = false
	
	if not ns.db.groupUpSameItems then 
		return false
	end
	
	for i=1, #list do
		if list[i] == link then
			exists = true
			
			local linkNum = ns.NumericItemLink(link, 'Server_GroupedItemInList:1')
			
			groupedItems[linkNum] = true
			break
		end
	end
	
	return exists
end

function ns.Server_ClearUngroupedItems()
	for link, amount in pairs(tempGroupedItems) do
		if amount > 1 then
		
		--	print('T', link, amount)
			groupedItems[link] = amount
		end
	end
	
	wipe(tempGroupedItems)
end

function ns.Server_ItemIsGrouped(link)

	if not ns.db.groupUpSameItems then 
		return false
	end
	
	local link1 = ns.NumericItemLink(link, 'Server_ItemIsGrouped:1')
	
	if groupedItems[link1] then
		return true
	end
	
	return false, link1
end
function ns.Server_RemoveItemGroup(link)
	groupedItems[ns.NumericItemLink(link, 'Server_RemoveItemGroup:1')] = nil
end

function ns.Server_GetAmountGroupedItems(link)
	local index = 0
	
	if not ns.db.groupUpSameItems then 
		return index
	end
	
	local link1 = ns.NumericItemLink(link, 'Server_GetAmountGroupedItems:1')
	
	for slot=1, GetNumLootItems() do		
		if LootSlotHasItem(slot) then	
			local tLink = GetLootSlotLink(slot)

			if tLink then
			--	print('T', slot, tLink, ns.NumericItemLink(tLink, 'Server_GetAmountGroupedItems:2'),  link1)
				if ns.NumericItemLink(tLink, 'Server_GetAmountGroupedItems:3') == link1 then
					index = index + 1
				end
			end
		end
	end
	
	return index
end

function ns:GetMasterLootCandidateIndex(slot, name)
	local tName1 = Ambiguate(name, "short")
	for i=1, 40 do
		local name2 = GetMasterLootCandidate(slot, i)
		
	--	print('T', i, name, tName1, name2)
		if name2 then
			tName2 = Ambiguate(name2, "short")
			if tName1 == tName2 then
				return i
			end
		end
	end
end

function ns:GetMasterLootItemSlotByLink(link)
	for slot=1, GetNumLootItems() do		
		if LootSlotHasItem(slot) then
	
			local tLink = GetLootSlotLink(slot)
			
			if tLink == link then
				return slot
			end
		end
	end
end

local function ItemIcon_StartToll_OnEnter(self)
	self.highlight:Show()
end

local function ItemIcon_StartToll_OnLeave(self)
	self.highlight:Hide()
end

local function CreateItemIcon(frame)

	local button = CreateFrame("Button")
	button:SetSize(IconSize, IconSize)
	button:SetParent(frame)
	button:SetFrameLevel(frame:GetFrameLevel()+1)
	
	button:SetScript("OnEnter", SetItemTip)
	button:SetScript("OnLeave", HideTip2)
--	button:SetScript("OnUpdate", ItemOnUpdate)
	button:SetScript("OnClick", LootClick)
	button:SetScript('OnEvent', SetItemTip)
	
	button.icon = button:CreateTexture(nil, 'OVERLAY')
	button.icon:SetAllPoints()
	button.icon:SetTexCoord(0.07, 0.93, 0.07, 0.93)
	
	button.RelicBorder = button:CreateTexture()
	button.RelicBorder:SetDrawLayer('OVERLAY', 1)
	button.RelicBorder:SetSize(IconSize, IconSize)
	button.RelicBorder:SetPoint('CENTER', button, 'CENTER', 0, 0)
	button.RelicBorder:SetTexCoord(0.04, 0.96, 0.04, 0.96)
	button.RelicBorder:SetTexture([[Interface\Artifacts\RelicIconFrame]]);
	
	button.icon.bg = button:CreateTexture(nil, 'OVERLAY', nil, -1)
	ns.CustomSetTexture(button.icon.bg, 0, 0, 0, 1)
	button.icon.bg:SetPoint('TOPLEFT', button.icon, 'TOPLEFT', -1, 1)
	button.icon.bg:SetPoint('BOTTOMRIGHT', button.icon, 'BOTTOMRIGHT', 1, -1)
	
	local text = button:CreateFontString(nil, "OVERLAY")
	text:SetFont(ns.default_font, ns.default_font_size+2, 'OUTLINE')
	text:SetPoint("BOTTOM", button.icon, "BOTTOM", 0, 0)
	text:SetSize(50, 50)
	text:SetJustifyH("CENTER")
	text:SetJustifyV("BOTTOM")	
	text:SetTextColor(1, 1, 1, 1)
	text:SetShadowColor(0,0,0,1)
	text:SetShadowOffset(1,-1)
	text:SetWordWrap(true)
	
	button.text = text
		
	local startRoll = CreateFrame("Button")
	startRoll:SetParent(button)
	startRoll:SetSize(10, 14)	
	startRoll:SetPoint('TOPLEFT', button, 'BOTTOMLEFT', 0, -3)
	startRoll:SetPoint('TOPRIGHT', button, 'TOPRIGHT', 0, -3)
	
	startRoll.bg = startRoll:CreateTexture()
	startRoll.bg:SetDrawLayer('OVERLAY', 1)
	startRoll.bg:SetAllPoints()
	startRoll.bg:SetTexture(ns.buttonsTexture)
	startRoll.bg:SetVertexColor(0.2, 0.4, 0.2, 1)
	
	startRoll.highlight = startRoll:CreateTexture()
	startRoll.highlight:SetDrawLayer('OVERLAY', 2)
	startRoll.highlight:SetAllPoints()
	ns.CustomSetTexture(startRoll.highlight, 1,1,1,0.2)
	startRoll.highlight:Hide()
	
	
	startRoll.border = startRoll:CreateTexture()
	startRoll.border:SetDrawLayer('OVERLAY', 0)
	startRoll.border:SetPoint("TOPLEFT", startRoll.bg, 'TOPLEFT', -1, 1)
	startRoll.border:SetPoint("BOTTOMRIGHT", startRoll.bg, 'BOTTOMRIGHT', 1, -1)
	ns.CustomSetTexture(startRoll.border, 0, 0, 0, 1)
	
	startRoll.text = startRoll:CreateFontString()
	startRoll.text:SetDrawLayer('OVERLAY', 0)
	startRoll.text:SetPoint('CENTER', startRoll, 'CENTER', 0, 2)
	startRoll.text:SetFont(ns.default_font, ns.default_font_size, ns.default_font_outline)
	startRoll.text:SetText(L['GUI_ROLL'])	
	startRoll.text:SetShadowColor(0,0,0,1)
	startRoll.text:SetShadowOffset(1,-1)
	startRoll:SetScript("OnEnter", ItemIcon_StartToll_OnEnter)
	startRoll:SetScript("OnLeave", ItemIcon_StartToll_OnLeave)
	startRoll:SetScript('OnMouseUp', function(self)
		self.text:SetPoint('CENTER', self, 'CENTER', 0, 2)
	end)
	startRoll:SetScript('OnMouseDown', function(self)
		self.text:SetPoint('CENTER', self, 'CENTER', 1, 1)
	end)

	startRoll:SetScript('OnClick', function(self, button)
		ns.print('T', 'OnClick', 'startRoll', button)
		local frame = self:GetParent():GetParent()
		
		local itemList = {}
		
		for i=1, #frame.icons do
			if frame.icons[i] == self:GetParent() and frame.icons[i].link then
				itemList[i] = frame.icons[i].link
			elseif frame.icons[i].link then
				itemList[i] = 'NONE'
			end
		end
		
		if #itemList > 0 then
			ns:StartRollItem(frame.rollID, unpack(itemList))
		end
	end)
	
	button.startRoll = startRoll
	
	return button
end

function ns.FindExistedSession( itemList )
	
	if not ns.db.SearchSameSession then
		return false, false
	end
	
--	print('T', 'ns.FindExistedSession', #itemList)
--	print('T', 'ns.FindExistedSession', 'activeLootRolls', #activeLootRolls)
	
	for i=1, #activeLootRolls do
	
		local frame = activeLootRolls[i]
		local lootIndex = frame.lootIndex
		
--		print('T', 'ns.FindExistedSession', 'lootInterator[lootIndex]', lootInterator[lootIndex])
		
		if lootInterator[lootIndex] then
			local identi, sameValues = ns.CompareTables(lootInterator[lootIndex].itemList, itemList)
			
--			print('T', 'ns.FindExistedSession', 'identi, sameValues', identi, sameValues)
			
			if identi or sameValues then
			
--				print('T', identi, sameValues)
				
				return lootIndex, frame, identi, sameValues
			end
		end
	end

end

function ns:GetLootFrame(rollID)
	for i=1, #lootFrames do
		if lootFrames[i].rollID == rollID then return lootFrames[i] end
		if not lootFrames[i].rollID then return lootFrames[i] end
	end
	
	local frame = CreateFrame('Frame', nil, UIParent)
	frame:SetSize(352, IconSize + 14 + 9 + 10)
	frame:SetFrameStrata('HIGH')
	frame:SetFrameLevel(15)
	frame.bg = frame:CreateTexture(nil, 'BACKGROUND')
	frame.bg:SetAllPoints()
	ns.CustomSetTexture(frame.bg, 0, 0, 0, 0.8)
	
	frame:EnableMouse(true)
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnDragStart", function()
		ns:StartServerSideMoving()
	end)
	frame:SetScript("OnDragStop", function()
		ns:StopServerSideMoving()
	end)
	
	frame.shine = frame:CreateTexture(nil, 'BACKGROUND', nil, 1)
	frame.shine:SetAllPoints()
	ns.CustomSetTexture(frame.shine, 1, 1, 0, 0.7)
	frame.shine:SetAlpha(0)
	
	local ag = frame.shine:CreateAnimationGroup()
	local a1 = ag:CreateAnimation("Alpha")
	a1:SetFromAlpha(0)
	a1:SetToAlpha(0.6)
	a1:SetDuration(0.3)
	a1:SetOrder(1)
	
	local a2 = ag:CreateAnimation("Alpha")
	a2:SetFromAlpha(0.6)
	a2:SetToAlpha(0)
	a2:SetDuration(0.5)
	a2:SetOrder(2)
	
	frame.shine.ag = ag
	
	frame.Shine = function(self)
		frame.shine.ag:Play()
	end
	
	frame.left = frame:CreateTexture(nil, 'OVERLAY')
	frame.left:SetPoint('TOPLEFT', frame, 'TOPLEFT', 0, 0)
	frame.left:SetPoint('BOTTOMLEFT', frame, 'BOTTOMLEFT', 0, 0)
	frame.left:SetSize(1,1)
	ns.CustomSetTexture(frame.left, 0,0,0,1)
	
	frame.right = frame:CreateTexture(nil, 'OVERLAY')
	frame.right:SetPoint('TOPRIGHT', frame, 'TOPRIGHT', 0, 0)
	frame.right:SetPoint('BOTTOMRIGHT', frame, 'BOTTOMRIGHT', 0, 0)
	frame.right:SetSize(1,1)
	ns.CustomSetTexture(frame.right, 0,0,0,1)

	frame.bottom = frame:CreateTexture(nil, 'OVERLAY')
	frame.bottom:SetPoint('BOTTOMLEFT', frame, 'BOTTOMLEFT', 0, 0)
	frame.bottom:SetPoint('BOTTOMRIGHT', frame, 'BOTTOMRIGHT', 0, 0)
	frame.bottom:SetSize(1,1)
	ns.CustomSetTexture(frame.bottom, 0,0,0,1)
	
	frame.top = frame:CreateTexture(nil, 'OVERLAY')
	frame.top:SetPoint('TOPLEFT', frame, 'TOPLEFT', 0, 0)
	frame.top:SetPoint('TOPRIGHT', frame, 'TOPRIGHT', 0, 0)
	frame.top:SetSize(1,1)
	ns.CustomSetTexture(frame.top, 0,0,0,1)

	frame:Show()
	
	frame.rollID = rollID
	
	frame.npcName = frame:CreateFontString()
	frame.npcName:SetFont(ns.default_font, ns.default_font_size+2, ns.default_font_outline)
	frame.npcName:SetPoint('TOPLEFT', frame, 'TOPLEFT', 2, -2)
	frame.npcName:SetShadowColor(0,0,0,1)
	frame.npcName:SetShadowOffset(1,-1)
	
	frame.icons = {}
	
	frame.receive = frame:CreateFontString()
	frame.receive:SetFont(ns.default_font, ns.default_font_size+2, ns.default_font_outline)
	frame.receive:SetPoint('TOP', frame, 'TOP', 60, -2)
	frame.receive:SetShadowColor(0,0,0,1)
	frame.receive:SetShadowOffset(1,-1)
	frame.receive:SetText('0/0')
	frame.receive.raid = {}
	
	frame.receive.overlay = CreateFrame('Frame', nil, frame)
	frame.receive.overlay:Hide()
	frame.receive.overlay.elapsed = 0
	frame.receive.overlay.text = frame.receive
	frame.receive.overlay:SetSize(1,1)
	frame.receive.overlay:SetAllPoints(frame.receive)
	frame.receive.overlay:SetScript('OnEnter', function(self)
	--	print('frame.receive.overlay OnEnter')
		self.elapsed = 1
		
		if self.text.tttext ~= '' then
			ns.ReceiveTooltip:Show()
			ns.ReceiveTooltip:SetParent(self)
			ns.ReceiveTooltip.text:SetPoint('BOTTOM', self, 'TOP', 0, 3)
		end
	end)
	frame.receive.overlay:SetScript('OnLeave', function(self)
	--	print('frame.receive.overlay OnLeave')
		ns.ReceiveTooltip:Hide()
	end)
	frame.receive.overlay:SetScript('OnUpdate', function(self,elapsed)
		self.elapsed = self.elapsed + elapsed
		if self.elapsed < 1 then return end
		self.elapsed = 0
		
		local numConfirm = 0
		local numFailed = 0
		local numTotal = 0
		
		local text = ''
		
		for unit, status in pairs(self.text.raid) do
			if status == 'CONFIRM' then
				numConfirm = numConfirm + 1
				numTotal = numTotal + 1
			elseif status == 'RESEND' then
				numFailed = numFailed + 1
				numTotal = numTotal + 1
				
				text = text..'|cFFFF0000'..UnitName(unit)..'|r\n'
			end			
		end
		
		for unit, status in pairs(self.text.raid) do
			if status == false then
				text = text..'|cFF606060'..UnitName(unit)..'|r\n'	
			end
		end
		
		local textColor = 'FF00FFFF'
		if numFailed > 0 then
			textColor = 'FFFF0000'
		elseif numConfirm == self.text.numOnline then
			textColor = 'FF00FF00'
		end
		
		self.text:SetText(format('|c%s%d/%d|r', textColor, numTotal, self.text.numOnline))
		
		self.text.tttext = text
		
		ns.ReceiveTooltip.text:SetText(text)
	end)
	
	frame.receive.Start = function(self)
		self:SetText('')
		wipe(self.raid)
		self.overlay:Hide()
		
		if ns.LastReveive then
			ns.LastReveive:End()
		end
		
		ns.LastReveive = self
		
		local numOnline = 0
		
		for i=1, GetNumGroupMembers() do
			if UnitIsConnected('raid'..i) then
				numOnline = numOnline + 1

				self.raid['raid'..i] = false
			end
		end

		self.numOnline = numOnline
		self.overlay:Show()
	end
	
	frame.receive.SetStatus = function(self, name, status)	
		for unit in pairs(self.raid) do			
			if string.find(name, (UnitName(unit))) then
				self.raid[unit] = status
				self.overlay.elapsed = 1
				return
			end
		end
	end
	
	frame.receive.End = function(self)
		self:SetText('')
		wipe(self.raid)
		self.overlay:Hide()
	end
	
	local startRoll = CreateFrame("Button")
	startRoll:SetParent(frame)
	startRoll:SetSize(54, 16)	
	startRoll:SetPoint('TOPRIGHT', frame, 'TOPRIGHT', -3, -18)
	
	startRoll.bg = startRoll:CreateTexture()
	startRoll.bg:SetDrawLayer('OVERLAY', 1)
	startRoll.bg:SetAllPoints()
	startRoll.bg:SetTexture(ns.buttonsTexture)
	startRoll.bg:SetVertexColor(0.2, 0.4, 0.2, 1)
	
	startRoll.highlight = startRoll:CreateTexture()
	startRoll.highlight:SetDrawLayer('OVERLAY', 2)
	startRoll.highlight:SetAllPoints()
	ns.CustomSetTexture(startRoll.highlight, 1,1,1,0.2)
	startRoll.highlight:Hide()
	
	startRoll.border = startRoll:CreateTexture()
	startRoll.border:SetDrawLayer('OVERLAY', 0)
	startRoll.border:SetSize(1,1)
	startRoll.border:SetPoint("TOPLEFT", startRoll.bg, 'TOPLEFT', -1, 1)
	startRoll.border:SetPoint("BOTTOMRIGHT", startRoll.bg, 'BOTTOMRIGHT', 1, -1)
	ns.CustomSetTexture(startRoll.border, 0, 0, 0, 1)
	
	startRoll.text = startRoll:CreateFontString()
	startRoll.text:SetDrawLayer('OVERLAY')
	startRoll.text:SetPoint('CENTER', startRoll, 'CENTER', 0, 0)
	startRoll.text:SetFont(ns.default_font, ns.default_font_size, ns.default_font_outline)
	startRoll.text:SetText(L['GUI_ROLLALL'])	
	startRoll.text:SetShadowColor(0,0,0,1)
	startRoll.text:SetShadowOffset(1,-1)
	startRoll:SetScript('OnEnter', function(self)
		self.highlight:Show()
	end)
	startRoll:SetScript('OnLeave', function(self)
		self.highlight:Hide()
	end)
	startRoll:SetScript('OnMouseUp', function(self)
		self.text:SetPoint('CENTER', self, 'CENTER', 0, 0)
	end)
	startRoll:SetScript('OnMouseDown', function(self)
		self.text:SetPoint('CENTER', self, 'CENTER', 1, -1)
	end)
	startRoll:SetScript('OnClick', function(self, button)
		ns.print('T', 'OnClick', 'startRoll', button)
		local frame = self:GetParent()
		local itemList = {}
		for i=1, #frame.icons do
			if frame.icons[i].link then
				itemList[i] = frame.icons[i].link
			end
		end
		
		if #itemList > 0 then
			ns:StartRollItem(frame.rollID, unpack(itemList))
			
			ns.DoStartRollAnonce(frame)
		end
		
		frame.receive:Start()
	end)
	
	local cancelRoll = CreateFrame("Button")
	cancelRoll:SetParent(frame)
	cancelRoll:SetSize(54, 16)	
	cancelRoll:SetPoint('TOPRIGHT', startRoll, 'BOTTOMRIGHT', 0, -3)
	
	cancelRoll.bg = cancelRoll:CreateTexture()
	cancelRoll.bg:SetDrawLayer('OVERLAY', 1)
	cancelRoll.bg:SetAllPoints()
	cancelRoll.bg:SetTexture(ns.buttonsTexture)
	cancelRoll.bg:SetVertexColor(0.6, 0.2, 0.2, 1)
	
	cancelRoll.highlight = cancelRoll:CreateTexture()
	cancelRoll.highlight:SetDrawLayer('OVERLAY', 2)
	cancelRoll.highlight:SetAllPoints()
	ns.CustomSetTexture(cancelRoll.highlight, 1,1,1,0.2)
	cancelRoll.highlight:Hide()
	
	cancelRoll.border = cancelRoll:CreateTexture()
	cancelRoll.border:SetDrawLayer('OVERLAY', 0)
	cancelRoll.border:SetSize(1,1)
	cancelRoll.border:SetPoint("TOPLEFT", cancelRoll.bg, 'TOPLEFT', -1, 1)
	cancelRoll.border:SetPoint("BOTTOMRIGHT", cancelRoll.bg, 'BOTTOMRIGHT', 1, -1)
	ns.CustomSetTexture(cancelRoll.border, 0, 0, 0, 1)
	
	cancelRoll.text = cancelRoll:CreateFontString()
	cancelRoll.text:SetDrawLayer('OVERLAY')
	cancelRoll.text:SetPoint('CENTER', cancelRoll, 'CENTER', 0, 0)
	cancelRoll.text:SetFont(ns.default_font, ns.default_font_size, ns.default_font_outline)
	cancelRoll.text:SetShadowColor(0,0,0,1)
	cancelRoll.text:SetShadowOffset(1,-1)
	cancelRoll.text:SetText(L['GUI_CANCEL'])	
	
	cancelRoll:SetScript('OnEnter', function(self)
		self.highlight:Show()
	end)
	cancelRoll:SetScript('OnLeave', function(self)
		self.highlight:Hide()
	end)
	cancelRoll:SetScript('OnMouseUp', function(self)
		self.text:SetPoint('CENTER', self, 'CENTER', 0, 0)
	end)
	cancelRoll:SetScript('OnMouseDown', function(self)
		self.text:SetPoint('CENTER', self, 'CENTER', 1, -1)
	end)
	cancelRoll:SetScript('OnClick', function(self, button)
		ns.print('T', 'OnClick', 'cancelRoll', button)
		
		for i=1, #activeLootRolls do
			if activeLootRolls[i] == self:GetParent() then
				
				for i2=1, #lootInterator[activeLootRolls[i].lootIndex].itemList do				
					ns.Server_RemoveItemGroup(lootInterator[activeLootRolls[i].lootIndex].itemList[i2])
				end
				
				table.remove(activeLootRolls, i)
				break
			end
		end
		
		ns:SendMessage(self:GetParent().rollID, ns.channelNameLootRollCancel)
		
		ns:ResetLastSession(self:GetParent().rollID)
		
		self:GetParent().rollID = nil
		self:GetParent().lootIndex = nil
		self:GetParent():Hide()

		ns:UpdateLootFrameGrid()
	end)
	
	frame.startRoll = startRoll
	frame.cancelRoll = cancelRoll
	
	lootFrames[#lootFrames+1] = frame
	
	return frame
end

local function UpdateItemIconGrid(frame, list)
	frame:SetSize(352,12)
	
	for i=1, #frame.icons do
		frame.icons[i].link = nil
		frame.icons[i]:Hide()
	end
	
	for i=1, #list do
		frame.icons[i] = frame.icons[i] or CreateItemIcon(frame)
		
		local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice,
			classID, subclassID, bindType = GetItemInfo(list[i])
		
		
		local itemInfoText = ''
		
	--	print('T', i, list[i], link)
		
		if ns.Server_ItemIsGrouped(list[i]) then
			itemInfoText = itemInfoText ..'x'..ns.Server_GetAmountGroupedItems(list[i])..'\n'
		end
		
		local itemLevelText = nil
		local itemPickStat = ''
		if iLevel and iLevel > 0 and ( ns.linkTypeItems[equipSlot] or IsArtifactRelicItem(link) ) then
			itemLevelText = iLevel
		end
	
		if ns.IsBindTypeBoE(bindType) then
			itemInfoText = itemInfoText..'|cFFFFFF00'
			itemPickStat = 'BoE'
		elseif ns.IsBindTypeBoP(bindType) then
			itemInfoText = itemInfoText..'|cFFFF0000'
			itemPickStat = 'BoP'
	--	elseif ns.CheckForContainTooltip(link1, ITEM_BIND_TO_BNETACCOUNT) then
	--		itemInfoText = 'BoA '
		end
	
		
		frame.icons[i].text:SetText(itemInfoText..(itemLevelText or itemPickStat)..'|r')
		frame.icons[i].link = link
		frame.icons[i].icon:SetTexture(texture)
		
		if link and IsArtifactRelicItem(link) then
			local color = ITEM_QUALITY_COLORS[quality]
	
			frame.icons[i].RelicBorder:Show()
			frame.icons[i].RelicBorder:SetVertexColor(color.r, color.g, color.b)
		else
			frame.icons[i].RelicBorder:Hide()
		end
	
		local cWidth, cHeight = frame:GetSize()
		local iWidth, iHeight = frame.icons[i]:GetSize()
		
		if i ==1 then 
			frame.icons[i]:SetPoint('TOPLEFT', frame.npcName, 'BOTTOMLEFT', 2, -4)
			
			frame:SetSize(352,12 + iHeight + 14 + 9 + 10)	
			
		elseif i == 9 or i == 17  or i == 26 or i == 35 then
			frame.icons[i]:SetPoint('TOPLEFT', frame.icons[i-8], 'BOTTOMLEFT', 0, -24)
			
			frame:SetSize(352, cHeight + iHeight + 14 + 9)		
		else
			frame.icons[i]:SetPoint('LEFT', frame.icons[i-1], 'RIGHT', 3, 0)
		end
		
		frame.icons[i]:Show()
	end
end

function ns:UpdateLootFrameGrid()
	for i=1, #activeLootRolls do
		local frame = activeLootRolls[i]
		frame:ClearAllPoints()
		
		if i == 1 then
			frame:SetPoint('TOPLEFT', mover, 'BOTTOMLEFT', 0, -3)
		else	
			frame:SetPoint('TOPLEFT', activeLootRolls[i-1] , 'BOTTOMLEFT', 0, -3)
		end
	end
end

local isMasterLooter = false
local playerFullName = nil

function ns:GetPlayerFullName()
	if playerFullName then return playerFullName end

	playerFullName = UnitName("player").."-"..GetRealmName():gsub(' ', '')
	
	return playerFullName
end

function ns:UnitIsUnit(unit1, unit2)
	if not unit1 or not unit2 then return false; end
	
	-- Remove realm names, if any
	unit1 = Ambiguate(unit1, "none")
	unit2 = Ambiguate(unit2, "none")

	return UnitIsUnit(unit1, unit2)
end

function ns:GetUnitFullName(unit)
	local server = GetRealmName()
	
	local name, realm = UnitFullName(unit)
	
	if server then
		server = server:gsub(' ', '')
	end
	
	if realm and realm ~= '' then
		realm = realm:gsub(' ', '')
	else
		realm = nil
	end
	
	return name, realm or server
end

local latestMasterLooter = nil

function ns:IsMasterLooter(real)
	if not real and ns.testMode then
		return true
	end
	
	local lootMethod, MLPartyID, MLRaidID = GetLootMethod()
	if lootMethod == 'master' then
		if MLRaidID then
			local name = GetRaidRosterInfo(MLRaidID)
			
			local isML = self:UnitIsUnit(name, "player");
			if isML then
				latestMasterLooter = name
			end
			return isML
		elseif MLPartyID then
			local name = UnitName( MLPartyID == 0 and 'player' or 'party'..MLPartyID)

			local isML = self:UnitIsUnit(name, "player");
			
			if isML then
				latestMasterLooter = name
			end
			
			return isML
		end
	elseif latestMasterLooter then	
		return self:UnitIsUnit(latestMasterLooter, "player");
	end
	
	return false
end

function ns:IsPlayerMasterLooter(playerName)

	local lootMethod, MLPartyID, MLRaidID = GetLootMethod()
	if lootMethod == 'master' then
		if MLRaidID then
			local name = GetRaidRosterInfo(MLRaidID)
			
			local isML = self:UnitIsUnit(name, playerName);
			if isML then
				latestMasterLooter = playerName
			end
			return isML
		elseif MLPartyID then
			local name = UnitName( MLPartyID == 0 and 'player' or 'party'..MLPartyID)
			
			local isML = self:UnitIsUnit(name, playerName);
			if isML then
				latestMasterLooter = playerName
			end
			return isML
		end
	elseif latestMasterLooter then	
		return self:UnitIsUnit(latestMasterLooter, playerName);
	end
	
	return false
end


local lastLootCount = nil
local lastLootInterator = nil

function ns:ResetLastSession(lootCount)
	if lootCount == lastLootCount then
		lastLootCount = nil
		lastLootInterator = nil
	end
end

local lastOpenedName
local lastLineID
local openSpellName = GetSpellInfo(6247)

function ns:GetForLootSourceName()
	local name
	
	if lastOpenedName then
		name = lastOpenedName
	elseif UnitIsDeadOrGhost('target') then
		name = UnitName('target')
	end
	
	return name
end


function events:UNIT_SPELLCAST_SENT(event, unitID, spell, rank, target, lineID)
	if spell == openSpellName then
		lastLineID = lineID
		lastOpenedName = target
	end
end

function events:UNIT_SPELLCAST_SUCCEEDED(event, unitID, spell, rank, lineID, spellID)
	if spell == openSpellName then	
		if lineID ~=  lastLineID then
			lastOpenedName = nil
			ns.print('T', 'USCS', 'Wrong lineID', 'ClearTarget')
		else
			ns.print('T', 'USCS', 'Succeeded', lastOpenedName)
		end
	end
end

local guidsList = {}
function ns:GetLootBossID()
	wipe(guidsList)
	
	for i = 1, GetNumLootItems() do
		for n = 1, select("#", GetLootSourceInfo(i)), 2 do
			local GUID = select(n, GetLootSourceInfo(i))
			
			if not guidsList[GUID] then
				guidsList[GUID] = true
				
				local bossID, instanceID, bossName, instanceName = ns.Cache_GetItemSourceByGUID(GUID)
				
				if bossID then
			--		print('Find Boss', bossName, instanceName)
					return bossID
				end
			end
		end
	end
	
	return false
end


function events:LOOT_OPENED(event, ...)
	ns.LootOpened = true

	if not ns:IsMasterLooter() then return end
	if not ns:IsInstanceIgnored_Server() then return end
	
	ns.print("T", 'LOOT_OPENED', 'GetForLootSourceName', ns:GetForLootSourceName())

	local itemList = {}
	local bossID = ns:GetLootBossID()
	
	for i=1,  GetNumLootItems() do		
		local texture, item, quantity, quality, locked, isQuestItem, questId, isActive = GetLootSlotInfo(i);
		local link = GetLootSlotLink(i)
		if link then		
			local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(link)			
			if link and quality and ns.db.lootQuality[quality] then
				if subclass and ns.subClassItemIgnore[ subclass ] then
				
				else
					ns.print('T', i, LootSlotHasItem(i), name, class, subclass, equipSlot)		
					
					if not bossID then
						bossID = ns.Cache_GetItemIDInfo(ns.GetItemID(link))
					end
					
					ns:SaveItemBossInfo(link, bossID)
					
					if not ns.Server_GroupedItemInList(link, itemList) then
						itemList[#itemList+1] = link
					end
				end
			end
		end
	end
	
--	ns.Server_ClearUngroupedItems()
	
	if #itemList == 0 then return end
	
	local unitGUID = UnitGUID('target')
	local unitName = ns.Cache_GetBossNameByID(bossID) or ns:GetForLootSourceName()
	local lootIndex = #lootInterator+1
	local lootCount = 'Loot#'..lootIndex
	
	lastLootCount = lootCount
	lastLootInterator = lootIndex
	
	ns.print('T', 'LootCount',lootCount)
	
	local lootIndex_finded, frame_finded, identi, sameValues = ns.FindExistedSession( itemList )
	
	if identi or sameValues then
	
		unitGUID = lootInterator[lootIndex_finded].guid
		unitName = lootInterator[lootIndex_finded].name
		lootIndex = lootIndex_finded
		lootCount = lootInterator[lootIndex_finded].rollID
		
		lastLootCount = lootCount
		lastLootInterator = lootIndex
		
		lootInterator[lootIndex].itemList = itemList
	else

		lootInterator[lootIndex] = { itemList = itemList, guid = unitGUID, name = unitName, index = lootIndex, rollID = lootCount }
		
		if ns.db.enableScreenShot then
			Screenshot()
		end
	end
	
	
	local frame = ns:GetLootFrame(lootCount)
	frame:Show()	
	frame.rollID = lootCount
	frame.lootIndex = lootIndex
	frame.receive:End()
	
	UpdateItemIconGrid(frame, itemList)
	frame.npcNameText = ( unitName or L['GUI_UNKNOWN_SOURCE'] )
	frame.npcName:SetText('#'..lootIndex..'. '..frame.npcNameText)

	if frame_finded then
		frame:Shine()
	else
		activeLootRolls[#activeLootRolls+1] = frame
	end
	
	ns.TakeAllItemsButton:SetParent(frame)
	ns.TakeAllItemsButton:ClearAllPoints()
	ns.TakeAllItemsButton:Show()
	ns.TakeAllItemsButton:SetPoint('TOPRIGHT', frame.cancelRoll, 'BOTTOMRIGHT', 0, -3)
	
	ns:ShowGiveItButtons()
	
	ns:UpdateLootFrameGrid()
end

function events:LOOT_SLOT_CLEARED(event, slotID)
	ns.LootOpened = true
	
	if not ns:IsMasterLooter() then return end
	
	if not lastLootCount then return end
	if not lastLootInterator then return end
	if not lootInterator[lastLootInterator] then return end
	
	local unitGUID = UnitGUID('target')
	local unitName = ns.Cache_GetBossNameByID(bossID) or ns:GetForLootSourceName()
	local lootIndex = lastLootInterator
	local lootCount = lastLootCount
	
	lastLootCount = lootCount
	
	ns.print('T', 'LootCount', event, lootCount)
	
	local itemList = {}
	local bossID = ns:GetLootBossID()
	
	for i=1,  GetNumLootItems() do		
		local texture, item, quantity, quality, locked, isQuestItem, questId, isActive = GetLootSlotInfo(i);
		local link = GetLootSlotLink(i)
		if link then		
			local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = GetItemInfo(link)			
			if link and quality and ns.db.lootQuality[quality] then
				ns.print('T', i, LootSlotHasItem(i), name, class, subclass, equipSlot)	

				if not bossID then
					bossID = ns.Cache_GetItemIDInfo(ns.GetItemID(link))
				end
				
				ns:SaveItemBossInfo(link, bossID)
				
				if not ns.Server_GroupedItemInList(link, itemList) then
					itemList[#itemList+1] = link
				end
			end
		end
	end
	
--	ns.Server_ClearUngroupedItems()
	
	if #itemList == 0 then
		lootInterator[lootIndex].itemList = itemList
		local frame = ns:GetLootFrame(lootCount)
		
		for i=1, #activeLootRolls do
			if activeLootRolls[i] == frame then		
				local frame = table.remove(activeLootRolls, i)
				frame:Hide()
				
				for i2=1, #lootInterator[frame.lootIndex].itemList do				
					ns.Server_RemoveItemGroup(lootInterator[frame.lootIndex].itemList[i2])
				end
				
				ns:SendMessage(frame.rollID, ns.channelNameLootRollCancel)
				ns:ResetLastSession(frame.rollID)
				
				frame.rollID = nil
				frame.lootIndex = nil
				
				UpdateItemIconGrid(frame, itemList)				
				break
			end
		end
		ns:UpdateLootFrameGrid()
		return 
	end
	
	lootInterator[lootIndex].itemList = itemList
	
	local frame = ns:GetLootFrame(lootCount)
	frame:Show()	
	frame.rollID = lootCount
	frame.lootIndex = lootIndex
	frame.receive:End()
	
	UpdateItemIconGrid(frame, itemList)
	frame.npcNameText = ( unitName or L['GUI_UNKNOWN_SOURCE'] )
	frame.npcName:SetText('#'..lootIndex..'. '..frame.npcNameText)
	
	ns.TakeAllItemsButton:SetParent(frame)
	ns.TakeAllItemsButton:ClearAllPoints()
	ns.TakeAllItemsButton:Show()
	ns.TakeAllItemsButton:SetPoint('TOPRIGHT', frame.cancelRoll, 'BOTTOMRIGHT', 0, -3)
	
	ns:ShowGiveItButtons()
	
	ns:UpdateLootFrameGrid()
end
events.LOOT_SLOT_CHANGED = events.LOOT_SLOT_CLEARED

function events:LOOT_CLOSED(event, ...)
	ns.LootOpened = false
	
	ns.TakeAllItemsButton:SetParent(nil)
	ns.TakeAllItemsButton:ClearAllPoints()
	ns.TakeAllItemsButton:Hide()
	
	lastOpenedName = nil
	
	ns:HideGiveItButtons()
end

local fake_links = {
	"\124Hitem:87777:0:0:0:0:0:0:0:0:0:0\124h[Reins of the Astral Cloud Serpent]\124h",
	"\124Hitem:124519:0:0:0:0:0:0:0:0:0:529:0:1:0\124h[Repudiation of War]\124h",
	"\124Hitem:127959:0:0:0:0:0:0:0:0:0:0:0:1:0\124h[Helm of Hellfire's Vanquisher]\124h",
	"\124Hitem:127959:0:0:0:0:0:0:0:0:0:0:0:1:0\124h[Helm of Hellfire's Vanquisher]\124h",
	"\124Hitem:127959:0:0:0:0:0:0:0:0:0:0:0:1:0\124h[Helm of Hellfire's Vanquisher]\124h",
	"\124Hitem:116660:0:0:0:0:0:0:0:0:0:0\124h[Ironhoof Destroyer]\124h",
	"\124Hitem:124367:0:0:0:0:0:0:0:0:0:529:0:2:562:567\124h[Fang of the Pit]\124h",
	"\124Hitem:124367:0:0:0:0:0:0:0:0:0:529:0:2:562:567\124h[Fang of the Pit]\124h",
	"\124Hitem:124367:0:0:0:0:0:0:0:0:0:529:0:2:562:567\124h[Fang of the Pit]\124h",
	"\124Hitem:124367:0:0:0:0:0:0:0:0:0:529:0:2:562:567\124h[Fang of the Pit]\124h",
	"\124Hitem:140896::::::::110::::1:3443:\124h[Ring of Braided Stems]\124h",
}
local fake_BossIDs = { 105503, 102263, 76865, 89890}
local fake_Relic = {
	"\124Hitem:141514:0:0:0:0:0:0:0:0:0:0:0:1:0\124h[N]\124h",
	
	"\124Hitem:139251:0:0:0:0:0:0:0:0:0:0:0:1:0\124h[N]\124h",
	"\124Hitem:139250:0:0:0:0:0:0:0:0:0:0:0:1:0\124h[N]\124h",
	"\124Hitem:139252:0:0:0:0:0:0:0:0:0:0:0:1:0\124h[N]\124h",
	
	"\124Hitem:139254:0:0:0:0:0:0:0:0:0:0:0:1:0\124h[N]\124h",
}


function ns.CreateFakeLootSession()
	ns.LootOpened = true
	
	if not ns:IsMasterLooter() then return end
--	if not ns:IsInstanceIgnored_Server() then return end
	
	ns.print("T", 'LOOT_OPENED', 'GetForLootSourceName', ns:GetForLootSourceName())


	local itemList = {}
	local bossID = fake_BossIDs[fastrandom(1 ,#fake_BossIDs)]
	
	for i=1,  #(ns.relicTest and fake_Relic or fake_links) do		
		local link = (ns.relicTest and fake_Relic or fake_links)[i]
		
		ns:SaveItemBossInfo(link, bossID)
		
		if not ns.Server_GroupedItemInList(link, itemList) then
			itemList[#itemList+1] = link
		end
	end
	
--	ns.Server_ClearUngroupedItems()
	
	if #itemList == 0 then return end
	
	local unitGUID = 'FakeGUID'
	local unitName = ns.Cache_GetBossNameByID(bossID) or 'FakeName'
	local lootIndex = #lootInterator+1
	local lootCount = 'Loot#'..lootIndex
	
	lastLootCount = lootCount
	lastLootInterator = lootIndex
	
	ns.print('T', 'CreateFakeLootSession', 'LootCount', lootCount)
	
	local lootIndex_finded, frame_finded, identi, sameValues = ns.FindExistedSession( itemList )
	
	if identi or sameValues then
	
		unitGUID = lootInterator[lootIndex_finded].guid
		unitName = lootInterator[lootIndex_finded].name
		lootIndex = lootIndex_finded
		lootCount = lootInterator[lootIndex_finded].rollID
		
		lastLootCount = lootCount
		lastLootInterator = lootIndex
		
		lootInterator[lootIndex].itemList = itemList
	else
	
		lootInterator[lootIndex] = { itemList = itemList, guid = unitGUID, name = unitName, index = lootIndex, rollID = lootCount }
		
		if ns.db.enableScreenShot then
			Screenshot()
		end
	end
	
	local frame = ns:GetLootFrame(lootCount)
	frame:Show()	
	frame.rollID = lootCount
	frame.lootIndex = lootIndex
	frame.receive:End()
	
	UpdateItemIconGrid(frame, itemList)
	frame.npcNameText = ( unitName or L['GUI_UNKNOWN_SOURCE'] )
	frame.npcName:SetText('#'..lootIndex..'. '..frame.npcNameText)
	
	if frame_finded then
		frame:Shine()
	else
		activeLootRolls[#activeLootRolls+1] = frame
	end
	
	ns.TakeAllItemsButton:SetParent(frame)
	ns.TakeAllItemsButton:ClearAllPoints()
	ns.TakeAllItemsButton:Show()
	ns.TakeAllItemsButton:SetPoint('TOPRIGHT', frame.cancelRoll, 'BOTTOMRIGHT', 0, -3)
	
	ns:ShowGiveItButtons()
	
	ns:UpdateLootFrameGrid()

end

function ns.ItemIsAwarded_Blizzard(buttonType, slot, link, name, syncMsg)
	
--	print('LH', ns.ShortLinkName(link), '->', ns.GetColoredName(name), '(|cFF00FF00'..L['ITEM_AWARDED']..'|r)','BT:',buttonType, 'Blizz')
		
	ns:SendMessage( syncMsg , ns.channelNameLootRollAward)
	
	if ns.Slot_QueueList[slot] then
		ns.BreakQueueFunctionByID(ns.Slot_QueueList[slot])		
		ns.Slot_QueueList[slot] = nil
	end
end

function ns.WaitForAwarding_Blizzard(buttonType, slot, link, name, syncMsg)

	local link_award_check = GetLootSlotLink(slot)
	
--	print('T', 'ns.WaitingForAwaring_Blizzard', 'link_award_check', link_award_check)
	
	if link_award_check then

		--ns.ErrorGiveItButton(button, 3)
		
		print('LH', ns.ShortLinkName(link), '->', ns.GetColoredName(name), '(|cFFFF0000'..L['Error']..'|r)')
		
--		print('T', 'ns.WaitingForAwaring_Blizzard', 'Error')
		if ns.Slot_QueueList[slot] then
			ns.Slot_QueueList[slot] = false
		end
	else
		
		ns.ItemIsAwarded_Blizzard(buttonType, slot, link, name, syncMsg)
	end

end

hooksecurefunc('GiveMasterLoot', function(slot, index, trigger)

	local isLootHelperMove = false 
	local AutoLoot = false
	--[==[
	for i=1, select('#', ...) do
		
		local arg = select(i, ...)
		
		if arg == 'LHRun' then
			isLootHelperMove = true
			break
		elseif arg == 'LHLootAll' then
			AutoLoot = true
			break
		end
	end
	]==]
	
	if trigger == 'LHRun' then
		isLootHelperMove = true
	elseif trigger == 'LHLootAll' then
		AutoLoot = true
	end

--	print('T', 'GiveMasterLoot', slot, index, ...)
	
	
	-- name className, classFile = GetMasterLootCandidate(slot, index)
	ns.print('T', 'Hook', 'GiveMasterLoot', slot, index, GetMasterLootCandidate(slot, index))
	local name, className, classFile = GetMasterLootCandidate(slot, index)
	
	local link = GetLootSlotLink(slot)
	
	ns.dprint('LH_Fake', link, '->', name, className, 'trigger:', trigger or 'BlizzardUI')
	
	local unitName, unitServer = ns:GetUnitFullName(name)
	
	if not unitName then
		ns.dprint('|cFFFF0000LH_Fake','Unable to find unitName and/or unitServer for', name)
		return
	end
	
	local bossID = ns:GetItemBossInfo(link) or 0
	local syncMsg = unitName..'-'..unitServer..'\n'..classFile..'\n'..link..'\n-1\n'..tostring(bossID)
	
	local success, amountIndex
	
	if isLootHelperMove or AutoLoot then
		return
	end
	
	if not ns.Slot_QueueList[slot] then
		amountIndex = ns.QueueFunction(ns.timeWaitForCheck, 'WaitForAwarding_Blizzard', 'Blizzard', slot, link, name, syncMsg)
		
		ns.Slot_QueueList[slot] = amountIndex
	else
		success, amountIndex = ns.UpdateQueueFunction(ns.Slot_QueueList[slot], ns.timeWaitForCheck, 'WaitForAwarding_Blizzard', 'Blizzard', slot, link, name, syncMsg)		
	end
		
		
--	ns:SendMessage( unitName..'-'..unitServer..'\n'..classFile..'\n'..link , ns.channelNameLootRollAward)
end)

local timeOut = 0
function ns:SendRollButtons()
	if timeOut > GetTime() then return end
	timeOut = GetTime() + 10
	
	local msg = ''
	
	for i=1, ns.db.LootRollButtonsNumButtons do
		local data = ns.db.LootRollButtons[i]
	
		msg = format("%s%s\n%s\n%s\n%d\n", msg, data.name, data.tip, data.arg, data.icon)	
	end

	ns:SendMessage(msg, ns.channelNameLootRollButtons)
end

do

	function ns:SendAllowedForRoll()
		
		if not ns:IsMasterLooter() then return end
		

	end

end

function ns:StartRollItem(guid, ...)
	local msg = ''
	local numItems = select('#', ...)
	
	if numItems > 0 then
		
		ns:SendRollButtons()
		
		msg = msg .. guid .. '\n'
		
		for i=1, numItems do
		--	local item =  ns.ShortLink(select(i, ...))
			local item =  select(i, ...)
			
			
			if i < numItems then
				msg = msg .. item .. '\n'
			else
				msg = msg .. item
			end
		end	
		
		ns:SendMessage(msg, ns.channelNameLootRollStart)
	end
end

do
	local itemIDs = {}
	
	function ns:SaveItemBossInfo(item, bossID)
		if not item then 
			print('Usage: LootHelper:SaveItemBossInfo(itemID or itemLink, bossID)')
			return
		end
		
		local id
		
		if type(item) == 'number' then
			id = item
		else
			id = ns.GetItemID(item)
		end
		
		if not itemIDs[id] then	
			itemIDs[id] = bossID
		end
	end
	
	function ns:GetItemBossInfo(item)
		if not item then 
			print('Usage: LootHelper:GetItemBossInfo(itemID or itemLink)')
			return false
		end
		
		local id
		
		if type(item) == 'number' then
			id = item
		else
			id = ns.GetItemID(item)
		end
		
		return itemIDs[id] or false
	end
end

do
	local OUT_RAID = "out"
	local IN_RAID = 'in'
	
	local inRaid = OUT_RAID

	local raidLeaderWarning = true
	
	events:RegisterEvent("GROUP_ROSTER_UPDATE")
	events:RegisterEvent("PARTY_LEADER_CHANGED")
	events:RegisterEvent('PARTY_LOOT_METHOD_CHANGED')
	events:RegisterEvent('GUILD_PARTY_STATE_UPDATED')
	
	local LootMethod = {
		["personalloot"] = 'Персонализированная',
		["group"] = 'Групповая очередь',
		["freeforall"] = 'Каждый за себя',
		["master"] = 'Ответственный за добычу',
	}
	
	
	local function WarningIfMasterNotSet()
		if  ns.IsRealMasterLooter() then
		
		else
			ns.ShowMasterLootWarningGuild()
		end
	end
	
	
	StaticPopupDialogs.LH_ML_WARNING_GUILD = {
		text = 'LootHelper: Ваш рейд не является гильдейским. \n|cFFFF0000Нельзя|r установить систему разделения добычи на "'..MASTER_LOOTER..'"?',
		button1 = "Хорошо",
	--	button2 = CANCEL,
		OnAccept = function() end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = true,
		preferredIndex = 3,
	}
	
	StaticPopupDialogs.LH_ML_WARNING = {
		text = 'LootHelper: Вы являетесь лидером рейда. \nХотите установить систему разделения добычи на "'..MASTER_LOOTER..'"?',
		button1 = "Хорошо",
	--	button2 = CANCEL,
		OnAccept = function()
			SetLootMethod("master", 'player') 
			
			C_Timer.After(0.5, WarningIfMasterNotSet)
		end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = true,
		preferredIndex = 3,
	}
	
	StaticPopupDialogs.LH_ML_WARNING_CHANGED = {
		text = 'LootHelper: Система разделения добычи была изменена на ""',
		button1 = "Хорошо",
	--	button2 = CANCEL,
		OnAccept = function() 
		
		end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = true,
		preferredIndex = 3,
	}
	
	StaticPopupDialogs.LH_ML_WARNING_ISML = {
		text = 'LootHelper: Теперь вы является ответственным за разделение добычи.',
		button1 = "Хорошо",
	--	button2 = CANCEL,
		OnAccept = function() end,
		timeout = 0,
		whileDead = 1,
		hideOnEscape = true,
		preferredIndex = 3,
	}

	function ns.ShowMasterLootWarningGuild()
		StaticPopup_Show("LH_ML_WARNING_GUILD")
		
		--[==[
		AleaUI_GUI.ShowPopUp(
		   'LootHelper', 
		   'Ваш рейд не является гильдейским. \nНельзя установить систему разделения добычи на "'..MASTER_LOOTER..'"?',
		   nil, 
		   { name = "Хорошо", OnClick = function() end}		   
		)
		]==]
	end	
	
	local function WarningIfMasterNotSet()
		if  ns.IsRealMasterLooter() then
		
		else
			ns.ShowMasterLootWarningGuild()
		end
	end
	
	
	function ns.ShowMasterLootWarning()
		StaticPopup_Show("LH_ML_WARNING")
		
		--[==[
		AleaUI_GUI.ShowPopUp(
		   'LootHelper', 
		   'Вы являетесь лидером рейда. \nХотите установить систему разделения добычи на "'..MASTER_LOOTER..'"?',
		   { name = "Да", OnClick = function()
				SetLootMethod("master", 'player') 
				
				C_Timer.After(0.5, WarningIfMasterNotSet)
			end}, 
		   { name = "Нет", OnClick = function() end}		   
		)
		]==]
	end	
	
	function ns.ShowMasterLootError(method)
		StaticPopupDialogs.LH_ML_WARNING_CHANGED.text = 'LootHelper: Система разделения добычи была изменена на "'..method..'"'
		StaticPopup_Show("LH_ML_WARNING_CHANGED")
		
		--[==[
		AleaUI_GUI.ShowPopUp(
		   'LootHelper', 
		   'Система разделения добычи была изменена на "'..method..'"',
		   nil,
		   { name = "Хорошо", OnClick = function() end}			
		)	
		]==]
	end
	
	function ns.ShowMasterLooterAlertNotRL()
		StaticPopup_Show("LH_ML_WARNING_ISML")
		
		--[==[
		AleaUI_GUI.ShowPopUp(
		   'LootHelper', 
		   'Теперь вы является ответственным за разделение добычи.',
		   nil,
		   { name = "Хорошо", OnClick = function()  end}		   
		)
		]==]
	end
	
	function ns.IsPlayerRL()
		
		local index = UnitInRaid('player')
		
		if index then
			local name,rank = GetRaidRosterInfo(index)
			
			return rank == 2
		end
	
		return false
	end
	
	function ns.IsRealMasterLooter()
		
		local lootMethod, MLPartyID, MLRaidID = GetLootMethod()
		if lootMethod == 'master' then
			if MLRaidID then
				local name = GetRaidRosterInfo(MLRaidID)
				
				local isML = ns:UnitIsUnit(name, "player");

				return isML
			elseif MLPartyID then
				local name = UnitName( MLPartyID == 0 and 'player' or 'party'..MLPartyID)

				local isML = ns:UnitIsUnit(name, "player");
	
				return isML
			end
		end
	end

	function ns.DisableCheckMasterLooter()
		lastRaidLeader = nil
		lastMasterLooter = nil
		
	end
	
	function ns.CheckMasterLooter()
		
		local currentRaidLeader = ns.IsPlayerRL()
	
		if lastRaidLeader ~= currentRaidLeader and currentRaidLeader then
			lastRaidLeader = currentRaidLeader
		
			if ns.IsRealMasterLooter() then
			
			else
				ns.ShowMasterLootWarning()
			end
		elseif lastRaidLeader ~= currentRaidLeader and not currentRaidLeader then
			lastRaidLeader = currentRaidLeader
			lastMasterLooter = ns.IsRealMasterLooter()
		end
		
		local currentMasterLooter = ns.IsRealMasterLooter()
		
		if lastMasterLooter and not currentMasterLooter then
			lastMasterLooter = currentMasterLooter
			ns.ShowMasterLootError( ( GetLootMethod() and LootMethod[GetLootMethod()] or UNKNOWN ) )
		end
		
		if lastMasterLooter ~= currentMasterLooter and currentMasterLooter then
			lastMasterLooter = currentMasterLooter
			
			ns.ShowMasterLooterAlertNotRL()
		end

	end
	
	function events:GROUP_ROSTER_UPDATE()
		if not IsInRaid() then
			ns.DisableCheckMasterLooter()
		elseif IsInRaid() then
			ns.CheckMasterLooter()
		end
	end
	
	events.PARTY_LEADER_CHANGED = events.GROUP_ROSTER_UPDATE
	events.PARTY_LOOT_METHOD_CHANGED = events.GROUP_ROSTER_UPDATE
	events.GUILD_PARTY_STATE_UPDATED = events.GROUP_ROSTER_UPDATE
end


function ns:Server_ReceiveHandler(msg, sender)
	if not ns:IsMasterLooter() then return end
	
	if ns.LastReveive then
		ns.LastReveive:SetStatus(sender, msg)
	end
end

do
	local SendChatMessage = SendChatMessage
	local IsInRaid, IsInGroup = IsInRaid, IsInGroup
	local LE_PARTY_CATEGORY_INSTANCE = LE_PARTY_CATEGORY_INSTANCE
	local LE_PARTY_CATEGORY_HOME = LE_PARTY_CATEGORY_HOME
	
	function ns.ChatMessage(msg, chat, target)
		
		if chat == "RAID_WARNING" then
			SendChatMessage(msg, chat)
		elseif chat == "PARTY" then
			SendChatMessage(msg, ( IsInGroup(LE_PARTY_CATEGORY_INSTANCE) or IsInRaid(LE_PARTY_CATEGORY_INSTANCE) ) and "INSTANCE_CHAT" or chat)
		elseif chat == "GUILD" then
			SendChatMessage(msg, chat)
		elseif chat == "RAID" then		
			SendChatMessage(msg, ( IsInGroup(LE_PARTY_CATEGORY_INSTANCE) or IsInRaid(LE_PARTY_CATEGORY_INSTANCE) ) and "INSTANCE_CHAT" or chat)
		elseif chat == "WHISPER" and target then		
			SendChatMessage(msg, chat, nil, target)
		elseif chat == "SAY" or chat == "YELL" then 
			SendChatMessage(msg, chat)
		else
			local chatType = "SAY"
			if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) or IsInRaid(LE_PARTY_CATEGORY_INSTANCE) then
				chatType = "INSTANCE_CHAT"
			elseif IsInRaid(LE_PARTY_CATEGORY_HOME) then
				chatType = "RAID"
			elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
				chatType = "PARTY"
			end
			
			if chatType == "PRINT" then
				print(msg)
			else
				SendChatMessage(msg, chatType)
			end
		end
	end
end

function ns.IsPlayerRLorOfficer(unitName)
	local shortName = strsplit('-', unitName)
	for i=1,GetNumGroupMembers() do
		local name,rank = GetRaidRosterInfo(i)
		if name and (name == unitName or ( strsplit('-', name) ) == shortName) then
			if rank > 0 then
				return rank
			else
				return false
			end
		end
	end
	
	-- nil: not in party or raid
	-- false: no rl, no officer
	-- 1: officer
	-- 2: rl
end
	
local lastAnonceTimer = -1
function ns.DoStartRollAnonce(frame)
	
	if frame.npcNameText == L['GUI_UNKNOWN_SOURCE'] then
		return
	end
	
	if lastAnonceTimer > GetTime() then
		return
	end
	
	lastAnonceTimer = GetTime() + 5
	
	if not ns.db.doStartRollAnonce then
		return
	end
	
--	print('T', ns.IsPlayerRLorOfficer((UnitName('player'))))
	
	if ns.IsPlayerRLorOfficer((UnitName('player'))) then
		ns.ChatMessage('LootHelper: Начато разделение добычи для '..frame.npcNameText, "RAID_WARNING")
--		print('DoStartRollAnonce', 'RL', 'LootHelper: Начато разделение добычи для '..frame.npcNameText)
	elseif IsInRaid() then
		ns.ChatMessage('LootHelper: Начато разделение добычи для '..frame.npcNameText, 'RAID')
--		print('DoStartRollAnonce', 'NORMAL', 'LootHelper: Начато разделение добычи для '..frame.npcNameText)
	end
end